uses
  SysUtils, testlib;

const
  MAXN = 1000;
  MAXLEN = 1000000;

var
  ps, js : string;
  d1, d2 : array[1..MAXN] of longint;
  l, jl : array[1..MAXLEN] of longint;
  pk, jk, pmin, jmin, plen, jlen, s, a, t, b, n, m, i, dir : longint;

begin
  n := inf.readlongint;
  m := inf.readlongint;
  for i := 1 to n do begin
    d1[i] := inf.readlongint;
  end;
  for i := 1 to m do begin
    d2[i] := inf.readlongint;
  end;
  s := inf.readlongint;
  a := inf.readlongint;
  t := inf.readlongint;
  b := inf.readlongint;

  ps := ouf.readword(blanks, blanks);
  if (ps <> 'Impossible') and (ps <> 'Avenue') and (ps <> 'Street') then
    quit(_pe, 'Unknown first word: ' + ps);
  js := ans.readword(blanks, blanks);
  if (ps = 'Impossible') then begin
    if (js = 'Impossible') then
      quit(_ok, 'No solution');
    quit(_wa, 'Solution not found');
  end;
  pk := ouf.readlongint;
  pmin := n + m + 1;
  if (pk < 1) or (pk > MAXLEN) then
    quit(_wa, 'Wrong k: ' + IntToStr(pk));
  plen := 0;
  for i := 1 to pk do begin
    l[i] := ouf.readlongint;
    if (l[i] < 1) then
      quit(_wa, 'Wrong length of segment: ' + IntToStr(l[i]));
    if (l[i] >= n) and (l[i] >= m) then 
      quit(_wa, 'Too long segment: ' + IntToStr(l[i]));
    plen := plen + l[i];
    if (l[i] < pmin) then
      pmin := l[i];
  end;

  dir := 0;
  if (ps = 'Street') then dir := 1;
  for i := 1 to pk do begin
    if (dir = 0) then begin
      s := s + l[i] * d2[a];
      if (s < 1) or (s > n) then
        quit(_wa, 'Route is out of map: s = ' + IntToStr(s));
    end else begin
      a := a + l[i] * d1[s];
      if (a < 1) or (a > m) then
        quit(_wa, 'Route is out of map: a = ' + IntToStr(a));
    end;
    dir := 1 - dir;
  end;
  if (s <> t) or (a <> b) then
    quit(_wa, 'Wrong endpoint, expected: ' + IntToStr(t) + ', ' + IntToStr(b) + ', found: ' + IntToStr(s) + ', ' + IntToStr(a));

  if (js = 'Impossible') then
    quit(_fail, 'Contestant found solution!');
  jk := ans.readlongint;
  jlen := 0;
  jmin := n + m + 1;
  for i := 1 to jk do begin
    jl[i] := ans.readlongint;
    jlen := jlen + jl[i];
    if (jl[i] < jmin) then
      jmin := jl[i];
  end;

  if (jlen < plen) then
    quit(_wa, 'Jury has better length: ' + IntToStr(jlen) + ', instead of: ' + IntToStr(plen));
  if (plen < jlen) then
    quit(_fail, 'Contestant found better solution, length: ' + IntToStr(plen) + 'instead of: ' + IntToStr(jlen));
  if (jk < pk) then
    quit(_wa, 'Jury has better number of turns: ' + IntToStr(jk) + ', instead of: ' + IntToStr(pk));
  if (pk < jk) then
    quit(_fail, 'Contestant found better solution!');
  if (jmin > pmin) then
    quit(_wa, 'Jury has better shortest segment: ' + IntToStr(jmin) + ', instead of: ' + IntToStr(pmin));
  if (pmin > jmin) then
    quit(_fail, 'Contestant found better solution!');
  quit(_ok, 'Length = ' + IntToStr(jlen) + ', number of turns = ' + IntToStr(jk) + ', shortest segment = ' + IntToStr(jmin));
end.