import java.io.*;
import java.util.*;

public class yownerk_aa_fast {
	public static void main(String[] args) {
		new yownerk_aa_fast().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "yownerk";

	int MAXN = 1000;
	int MAX_TURN = 8;

	int INF = (int) 1e9;

	private void solve() throws IOException {
		long time = System.currentTimeMillis();
		n = nextInt();
		check(1 <= n && n <= MAXN);
		m = nextInt();
		check(1 <= m && m <= MAXN);
		ds = new int[n];
		for (int i = 0; i < ds.length; i++) {
			ds[i] = nextInt();
			check(Math.abs(ds[i]) == 1);
		}
		da = new int[m];
		for (int i = 0; i < da.length; i++) {
			da[i] = nextInt();
			check(Math.abs(da[i]) == 1);
		}
		int xs = nextInt() - 1;
		check(0 <= xs && xs < n);
		int ys = nextInt() - 1;
		check(0 <= ys && ys < m);
		xf = nextInt() - 1;
		check(0 <= xf && xf < n);
		yf = nextInt() - 1;
		check(0 <= yf && yf < m);
		state = new State[n][m][2];
		for (int i = 0; i < state.length; i++) {
			for (int j = 0; j < state[i].length; j++) {
				for (int k = 0; k < state[i][j].length; k++) {
					state[i][j][k] = new State(i, j, k, INF, INF);
				}
			}
		}
		System.out.println(System.currentTimeMillis() - time);
		Deque<State> deque = new ArrayDeque<yownerk_aa_fast.State>();
		state[xs][ys][0].d = 0;
		state[xs][ys][0].turns = 0;
		state[xs][ys][1].d = 0;
		state[xs][ys][1].turns = 0;
		deque.add(state[xs][ys][0]);
		deque.add(state[xs][ys][1]);
		while (!deque.isEmpty()) {
			State s = deque.pollFirst();
			int x = s.x;
			int y = s.y;
			{
				int xn = x + da[y];
				int yn = y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][0].d > s.d + 1) {
					state[xn][yn][0].d = s.d + 1;
					deque.addLast(state[xn][yn][0]);
				}
			}
			{
				int xn = x;
				int yn = y + ds[x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][1].d > s.d + 1) {
					state[xn][yn][1].d = s.d + 1;
					deque.addLast(state[xn][yn][1]);
				}
			}
			if (state[x][y][1 - s.dir].d > s.d) {
				state[x][y][1 - s.dir].d = s.d;
				deque.addFirst(state[x][y][1 - s.dir]);
			}
		}
		deque.clear();
		System.out.println(System.currentTimeMillis() - time);
		if (state[xf][yf][0].d >= INF) {
			out.println(impossible);
			return;
		}
		int minDist = state[xf][yf][0].d;
		deque.add(state[xf][yf][0]);
		state[xf][yf][0].onShort = 1;
		while (!deque.isEmpty()) {
			State s = deque.pollFirst();
			int x = s.x;
			int y = s.y;
			// System.out.println(x + " " + y + " " + s.dir);
			{
				int xn = x - da[y];
				int yn = y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][0].d == s.d - 1
						&& state[xn][yn][0].onShort == 0) {
					state[xn][yn][0].onShort = 1;
					deque.addLast(state[xn][yn][0]);
				}
			}
			{
				int xn = x;
				int yn = y - ds[x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][1].d == s.d - 1
						&& state[xn][yn][1].onShort == 0) {
					state[xn][yn][1].onShort = 1;
					deque.addLast(state[xn][yn][1]);
				}
			}
			if (state[x][y][1 - s.dir].d == s.d
					&& state[x][y][1 - s.dir].onShort == 0) {
				state[x][y][1 - s.dir].onShort = 1;
				deque.addFirst(state[x][y][1 - s.dir]);
			}
		}
		System.out.println(System.currentTimeMillis() - time);
		deque.addLast(state[xs][ys][0]);
		deque.addLast(state[xs][ys][1]);
		while (!deque.isEmpty()) {
			State s = deque.pollFirst();
			int x = s.x;
			int y = s.y;
			if (s.dir == 0) {
				// avenue
				int xn = x + da[y];
				int yn = y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					State sn = state[xn][yn][0];
					if (sn.onShort == 1 && sn.turns > s.turns) {
						sn.turns = s.turns;
						deque.addFirst(sn);
					}
				}
				State sn = state[x][y][1];
				if (sn.onShort == 1 && sn.turns > s.turns + 1) {
					sn.turns = s.turns + 1;
					deque.addLast(sn);
				}
			} else {
				// street
				int xn = x;
				int yn = y + ds[x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					State sn = state[xn][yn][1];
					if (sn.onShort == 1 && sn.turns > s.turns) {
						sn.turns = s.turns;
						deque.addFirst(sn);
					}
				}
				State sn = state[x][y][0];
				if (sn.onShort == 1 && sn.turns > s.turns + 1) {
					sn.turns = s.turns + 1;
					deque.addLast(sn);
				}
			}
		}
		System.out.println(System.currentTimeMillis() - time);
		if (state[xf][yf][0].turns <= state[xf][yf][1].turns) {
			state[xf][yf][0].onShort = 2;
			deque.add(state[xf][yf][0]);
		}
		if (state[xf][yf][0].turns >= state[xf][yf][1].turns) {
			state[xf][yf][1].onShort = 2;
			deque.add(state[xf][yf][1]);
		}
		while (!deque.isEmpty()) {
			State s = deque.pollFirst();
			int x = s.x;
			int y = s.y;
			// System.out.println(x + " " + y + " " + s.dir);
			if (s.dir == 0) {
				// avenue
				int xn = x - da[y];
				int yn = y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					State sn = state[xn][yn][0];
					if (sn.onShort == 1 && sn.turns == s.turns) {
						sn.onShort = 2;
						deque.addFirst(sn);
					}
				}
				State sn = state[x][y][1];
				if (sn.onShort == 1 && sn.turns == s.turns - 1) {
					sn.onShort = 2;
					deque.addLast(sn);
				}
			} else {
				// street
				int xn = x;
				int yn = y - ds[x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					State sn = state[xn][yn][1];
					if (sn.onShort == 1 && sn.turns == s.turns) {
						sn.onShort = 2;
						deque.addFirst(sn);
					}
				}
				State sn = state[x][y][0];
				if (sn.onShort == 1 && sn.turns == s.turns - 1) {
					sn.onShort = 2;
					deque.addLast(sn);
				}
			}
		}
		System.out.println(System.currentTimeMillis() - time);
		int l = 0;
		int r = minDist + 1;
		while (r - l > 1) {
			int min = (l + r) / 2;
			cur++;
			int xs1 = xs + da[ys] * min;
			int ys1 = ys;
			int xs2 = xs;
			int ys2 = ys + ds[xs] * min;
			boolean good = false;
			good = good
					|| (0 <= xs1 && xs1 < n && 0 <= ys1 && ys1 < m && dfs(
							state[xs1][ys1][0], min));
			good = good
					|| (0 <= xs2 && xs2 < n && 0 <= ys2 && ys2 < m && dfs(
							state[xs2][ys2][1], min));
			if (good) {
				l = min;
			} else {
				r = min;
			}
		}
		System.out.println(System.currentTimeMillis() - time);
		cur++;
		int xs1 = xs + da[ys] * l;
		int ys1 = ys;
		int xs2 = xs;
		int ys2 = ys + ds[xs] * l;
		boolean good = false;
		if (0 <= xs1 && xs1 < n && 0 <= ys1 && ys1 < m
				&& dfs(state[xs1][ys1][0], l)) {
			state[xs1][ys1][0].prev = state[xs][ys][0];
			good = true;
		}
		if (!good && 0 <= xs2 && xs2 < n && 0 <= ys2 && ys2 < m
				&& dfs(state[xs2][ys2][1], l)) {
			state[xs2][ys2][1].prev = state[xs][ys][1];
		}
		ArrayList<Integer> ans = new ArrayList<Integer>();
		State s = null;
		if (state[xf][yf][0].used == cur) {
			s = state[xf][yf][0];
		} else {
			s = state[xf][yf][1];
		}
		int sum = 0;
		while (s.x != xs || s.y != ys) {
			State ps = s.prev;
			sum += Math.abs(s.x - ps.x) + Math.abs(s.y - ps.y);
			if (s.dir == ps.dir) {
			} else {
				if (sum > 0) {
					ans.add(sum);
				}
				sum = 0;
			}
			s = ps;
		}
		// if (sum > 0) {
		ans.add(sum);
		// }
		if (s.dir == 0) {
			out.println(avenue);
		} else {
			out.println(street);
		}
		Collections.reverse(ans);
		out.println(ans.size());
		for (int i : ans) {
			out.print(i + " ");
		}
	}

	private boolean dfs(State s, int min) {
		s.used = cur;
		if (s.x == xf && s.y == yf) {
			return true;
		}
		if (s.dir == 0) {
			{
				int xn = s.x + da[s.y];
				int yn = s.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][0].onShort == 2) {
					if (state[xn][yn][0].used < cur
							&& dfs(state[xn][yn][0], min)) {
						state[xn][yn][0].prev = s;
						return true;
					}
				}
			}
			{
				int xn = s.x;
				int yn = s.y + ds[s.x] * min;
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][1].onShort == 2) {
					if (state[xn][yn][1].used < cur
							&& dfs(state[xn][yn][1], min)) {
						state[xn][yn][1].prev = s;
						return true;
					}
				}
			}
		} else {
			{
				int xn = s.x + da[s.y] * min;
				int yn = s.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][0].onShort == 2) {
					if (state[xn][yn][0].used < cur
							&& dfs(state[xn][yn][0], min)) {
						state[xn][yn][0].prev = s;
						return true;
					}
				}
			}
			{
				int xn = s.x;
				int yn = s.y + ds[s.x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m
						&& state[xn][yn][1].onShort == 2) {
					if (state[xn][yn][1].used < cur
							&& dfs(state[xn][yn][1], min)) {
						state[xn][yn][1].prev = s;
						return true;
					}
				}
			}
		}
		return false;
	}

	State[][][] state;
	int xf, yf;
	int[] ds, da;
	int n, m;
	int cur;

	class State {
		public State(int i, int j, int k, int iNF, int iNF2) {
			x = i;
			y = j;
			dir = k;
			d = iNF;
			turns = iNF2;
			onShort = 0;
			used = 0;
			prev = null;
		}

		final int x, y, dir;
		int d, turns;
		int onShort;
		int used;
		State prev;
	}

	String avenue = "Avenue";
	String street = "Street";
	String impossible = "Impossible";
}