import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.Random;
import java.util.StringTokenizer;

public class yownerk_aa_fast2 {
	public static void main(String[] args) {
		new yownerk_aa_fast2().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "yownerk";

	int MAXN = 1000;

	String impossible = "Impossible";
	String avenue = "Avenue";
	String street = "Street";

	int INF = (int) 1e9;

	private void solve() throws IOException {
		n = nextInt();
		check(1 <= n && n <= MAXN);
		m = nextInt();
		check(1 <= m && m <= MAXN);
		ds = new int[2][n];
		for (int i = 0; i < ds[1].length; i++) {
			ds[1][i] = nextInt();
			check(Math.abs(ds[1][i]) == 1);
		}
		da = new int[2][m];
		for (int i = 0; i < da[0].length; i++) {
			da[0][i] = nextInt();
			check(Math.abs(da[0][i]) == 1);
		}
		int xs = nextInt() - 1;
		check(0 <= xs && xs < n);
		int ys = nextInt() - 1;
		check(0 <= ys && ys < m);
		xf = nextInt() - 1;
		check(0 <= xf && xf < n);
		yf = nextInt() - 1;
		check(0 <= yf && yf < m);
		state = new boolean[n][m];
		int[][] dist = new int[n][m];
		int[] qx = new int[n * m];
		int[] qy = new int[qx.length];
		int h = 0;
		int t = 0;
		for (int i = 0; i < dist.length; i++) {
			Arrays.fill(dist[i], INF);
		}
		dist[xs][ys] = 0;
		qx[t] = xs;
		qy[t] = ys;
		t++;
		while (h != t && dist[xf][yf] >= INF) {
			int x = qx[h];
			int y = qy[h];
			h++;
			for (int i = 0; i < da.length; i++) {
				int xn = x + da[i][y];
				int yn = y + ds[i][x];
				if (valid(xn, yn) && dist[xn][yn] > dist[x][y] + 1) {
					dist[xn][yn] = dist[x][y] + 1;
					qx[t] = xn;
					qy[t] = yn;
					t++;
				}
			}
		}
		if (dist[xf][yf] >= INF) {
			out.println(impossible);
			return;
		}
		h = 0;
		t = 0;
		qx[t] = xf;
		qy[t] = yf;
		t++;
		state[xf][yf] = true;
		while (h != t) {
			int x = qx[h];
			int y = qy[h];
			h++;
			for (int i = 0; i < da.length; i++) {
				int xn = x - da[i][y];
				int yn = y - ds[i][x];
				if (valid(xn, yn) && dist[xn][yn] == dist[x][y] - 1) {
					state[xn][yn] = true;
					qx[t] = xn;
					qy[t] = yn;
					t++;
				}
			}
		}
		dist = null;
		wantedState = true;
		int[][][] turns = new int[2][n][m];
		for (int i = 0; i < turns.length; i++) {
			for (int j = 0; j < turns[i].length; j++) {
				Arrays.fill(turns[i][j], INF);
			}
		}
		qx = new int[4 * n * m];
		qy = new int[qx.length];
		int[] qd = new int[qx.length];
		h = 0;
		t = 0;
		turns[0][xs][ys] = 0;
		turns[1][xs][ys] = 0;
		qx[t] = xs;
		qy[t] = ys;
		qd[t] = 0;
		t++;
		qx[t] = xs;
		qy[t] = ys;
		qd[t] = 1;
		t++;
		while (h != t) {
			int x = qx[h];
			int y = qy[h];
			int d = qd[h];
			h++;
			if (turns[1 - d][x][y] > turns[d][x][y] + 1) {
				turns[1 - d][x][y] = turns[d][x][y] + 1;
				qx[t] = x;
				qy[t] = y;
				qd[t] = 1 - d;
				t++;
			}
			int xn = x + da[d][y];
			int yn = y + ds[d][x];
			if (valid(xn, yn) && turns[d][xn][yn] > turns[d][x][y]) {
				turns[d][xn][yn] = turns[d][x][y];
				h--;
				qx[h] = xn;
				qy[h] = yn;
				qd[h] = d;
			}
		}
		state2 = new boolean[2][n][m];
		int aTurns = Math.min(turns[0][xf][yf], turns[1][xf][yf]);
		h = 0;
		t = 0;
		for (int i = 0; i < turns.length; i++) {
			if (turns[i][xf][yf] == aTurns) {
				state2[i][xf][yf] = true;
				qx[t] = xf;
				qy[t] = yf;
				qd[t] = i;
				t++;
			}
		}
		while (h != t) {
			int x = qx[h];
			int y = qy[h];
			int d = qd[h];
			h++;
			if (turns[1 - d][x][y] == turns[d][x][y] - 1
					&& !state2[1 - d][x][y]) {
				state2[1 - d][x][y] = true;
				qx[t] = x;
				qy[t] = y;
				qd[t] = 1 - d;
				t++;
			}
			int xn = x - da[d][y];
			int yn = y - ds[d][x];
			if (valid(xn, yn) && turns[d][xn][yn] == turns[d][x][y]
					&& !state2[d][xn][yn]) {
				state2[d][xn][yn] = true;
				qx[t] = xn;
				qy[t] = yn;
				qd[t] = d;
				t++;
			}
		}
		int l = 1;
		int r = Math.min(n, m) + 1;
		prev = new int[2][n][m];
		u = new int[2][n][m];
		cur = 0;
		while (r - l > 1) {
			cur++;
			int min = (l + r) / 2;
			boolean good = false;
			for (int d = 0; d < da.length; d++) {
				int x = xs + da[d][ys] * min;
				int y = ys + ds[d][xs] * min;
				good = good
						|| (valid(x, y) && state2[d][x][y] && dfs(d, x, y, min));
			}
			if (good) {
				l = min;
			} else {
				r = min;
			}
		}
		cur++;
		boolean good = false;
		for (int d = 0; d < da.length; d++) {
			int x = xs + da[d][ys] * l;
			int y = ys + ds[d][xs] * l;
			good = good || (valid(x, y) && state2[d][x][y] && dfs(d, x, y, l));
			if (valid(x, y)) {
				prev[d][x][y] = 1 - d;
			}
		}
		int x = xf;
		int y = yf;
		int d = 0;
		if (u[d][x][y] < cur) {
			d++;
		}
		int[] ans = new int[aTurns + 1];
		int top = 0;
		int sum = 0;
		while (x != xs || y != ys) {
			int pd = prev[d][x][y];
			if (pd == d) {
				sum++;
				int xn = x - da[d][y];
				int yn = y - ds[d][x];
				x = xn;
				y = yn;
			} else {
				sum += l;
				ans[top++] = sum;
				sum = 0;
				int xn = x - da[d][y] * l;
				int yn = y - ds[d][x] * l;
				x = xn;
				y = yn;
				d = 1 - d;
			}
		}
		if (d == 1) {
			out.println(avenue);
		} else {
			out.println(street);
		}
		out.println(top);
		while (top > 0) {
			out.print(ans[--top]);
			if (top > 0) {
				out.print(" ");
			}
		}
		out.println();
	}

	private boolean dfs(int d, int x, int y, int min) {
		u[d][x][y] = cur;
		if (x == xf && y == yf) {
			return true;
		}
		{
			int xn = x + da[d][y];
			int yn = y + ds[d][x];
			if (valid(xn, yn) && state2[d][xn][yn] && u[d][xn][yn] < cur
					&& dfs(d, xn, yn, min)) {
				prev[d][xn][yn] = d;
				return true;
			}
		}
		{
			int xn = x + da[1 - d][y] * min;
			int yn = y + ds[1 - d][x] * min;
			if (valid(xn, yn) && state2[1 - d][xn][yn]
					&& u[1 - d][xn][yn] < cur && dfs(1 - d, xn, yn, min)) {
				prev[1 - d][xn][yn] = d;
				return true;
			}
		}
		return false;
	}

	int cur;
	int[][][] u;
	int[][][] prev; // previous direction
	boolean[][] state;
	boolean[][][] state2;
	boolean wantedState = false;

	private boolean valid(int xn, int yn) {
		return 0 <= xn && xn < n && 0 <= yn && yn < m
				&& state[xn][yn] == wantedState;
	}

	int n;
	int m;
	int xf;
	int yf;
	int[][] da;
	int[][] ds;
}