import java.io.*;
import java.util.*;

public class yownerk_aa_fast6_wrong {
	public static void main(String[] args) {
		new yownerk_aa_fast6_wrong().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "yownerk";

	int MAXN = 1000;

	private void solve() throws IOException {
		int n = nextInt();
		check(1 <= n && n <= MAXN);
		int m = nextInt();
		check(1 <= m && m <= MAXN);
		int[] ds = new int[n];
		for (int i = 0; i < ds.length; i++) {
			ds[i] = nextInt();
			check(Math.abs(ds[i]) == 1);
		}
		int[] da = new int[m];
		for (int i = 0; i < da.length; i++) {
			da[i] = nextInt();
			check(Math.abs(da[i]) == 1);
		}
		int xs = nextInt() - 1;
		check(0 <= xs && xs < n);
		int ys = nextInt() - 1;
		check(0 <= ys && ys < m);
		int xf = nextInt() - 1;
		check(0 <= xf && xf < n);
		int yf = nextInt() - 1;
		check(0 <= yf && yf < m);
		Path[][] a = new Path[n][m];
		Path[][] s = new Path[n][m];
		a[xs][ys] = new Path(avenue, xs, ys);
		s[xs][ys] = new Path(street, xs, ys);
		Path[] q = new Path[2 * n * m];
		int h = 0;
		int t = 0;
		q[t] = a[xs][ys];
		t = (t + 1) % q.length;
		q[t] = s[xs][ys];
		t = (t + 1) % q.length;
		int dist = Integer.MAX_VALUE / 2;
		while (h != t) {
			Path p = q[h];
			if (p.x == xf && p.y == yf) {
				if (dist > p.len) {
					dist = p.len;
				}
			}
			if (p.len > dist) {
				break;
			}
			h = (h + 1) % q.length;
			boolean lastAvenue = a[p.x][p.y] == p;
			if (lastAvenue) {
				int xn = p.x + da[p.y];
				int yn = p.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn);
					if (p2.better(a[xn][yn])) {
						a[xn][yn] = p2;
						q[t] = p2;
						t = (t + 1) % q.length;
					}
				}
				xn = p.x;
				yn = p.y + ds[p.x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn, 1);
					if (p2.better(s[xn][yn])) {
						s[xn][yn] = p2;
						q[t] = p2;
						t = (t + 1) % q.length;
					}
				}
			} else {
				int xn = p.x + da[p.y];
				int yn = p.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn, 1);
					if (p2.better(a[xn][yn])) {
						a[xn][yn] = p2;
						q[t] = p2;
						t = (t + 1) % q.length;
					}
				}
				xn = p.x;
				yn = p.y + ds[p.x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn);
					if (p2.better(s[xn][yn])) {
						s[xn][yn] = p2;
						q[t] = p2;
						t = (t + 1) % q.length;
					}
				}
			}
		}
		Path best = null;
		if (a[xf][yf] != null) {
			best = a[xf][yf];
		}
		if (s[xf][yf] != null) {
			if (best == null) {
				best = s[xf][yf];
			} else if (s[xf][yf].better(best)) {
				best = s[xf][yf];
			}
		}
		if (best == null) {
			out.println("Impossible");
		} else {
			String start = avenue;
			if (s[xf][yf] == best && best.turns % 2 == 0) {
				start = street;
			}
			if (a[xf][yf] == best && best.turns % 2 == 1) {
				start = street;
			}
			out.println(start);
			Path p = best;
			ArrayList<Integer> ans = new ArrayList<Integer>();
			while (p != null) {
				ans.add(p.c);
				p = p.prev;
			}
			Collections.reverse(ans);
			out.println(ans.size());
			for (int i : ans) {
				out.print(i + " ");
			}
		}
	}

	class Path {
		public Path(String type, int xs, int ys) {
			len = 0;
			c = 0;
			turns = 0;
			x = xs;
			y = ys;
			minPrev = Integer.MAX_VALUE / 2;
		}

		public boolean better(Path p) {
			if (p == null) {
				return true;
			}
			if (len < p.len) {
				return true;
			}
			if (len > p.len) {
				return false;
			}
			if (turns < p.turns) {
				return true;
			}
			if (turns > p.turns) {
				return false;
			}
			int min = c;
			if (minPrev < min) {
				min = minPrev;
			}
			int min2 = p.c;
			if (p.minPrev < min2) {
				min2 = p.minPrev;
			}
			return min > min2;
		}

		public Path(Path p, int xs, int ys) {
			len = p.len + 1;
			x = xs;
			y = ys;
			c = p.c + 1;
			turns = p.turns;
			prev = p.prev;
			minPrev = p.minPrev;
		}

		public Path(Path p, int xs, int ys, int i) {
			len = p.len + 1;
			x = xs;
			y = ys;
			c = 1;
			turns = p.turns + 1;
			prev = p;
			minPrev = p.minPrev;
			if (p.c < minPrev) {
				minPrev = p.c;
			}
		}

		int x, y;
		int len;
		int c;
		int turns;
		int minPrev;
		Path prev;
	}

	String avenue = "Avenue";
	String street = "Street";
}