import java.io.*;
import java.util.*;

public class yownerk_aa_fast_wrong {
	public static void main(String[] args) {
		new yownerk_aa_fast_wrong().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "yownerk";

	int MAXN = 1000;
	int MAX_TURN = 8;

	private void solve() throws IOException {
		int n = nextInt();
		check(1 <= n && n <= MAXN);
		int m = nextInt();
		check(1 <= m && m <= MAXN);
		int[] ds = new int[n];
		for (int i = 0; i < ds.length; i++) {
			ds[i] = nextInt();
			check(Math.abs(ds[i]) == 1);
		}
		int[] da = new int[m];
		for (int i = 0; i < da.length; i++) {
			da[i] = nextInt();
			check(Math.abs(da[i]) == 1);
		}
		int xs = nextInt() - 1;
		check(0 <= xs && xs < n);
		int ys = nextInt() - 1;
		check(0 <= ys && ys < m);
		int xf = nextInt() - 1;
		check(0 <= xf && xf < n);
		int yf = nextInt() - 1;
		check(0 <= yf && yf < m);
		Path[][] a = new Path[n][m];
		Path[][] s = new Path[n][m];
		a[xs][ys] = new Path(avenue, xs, ys);
		s[xs][ys] = new Path(street, xs, ys);
		Queue<Path> q = new ArrayDeque<yownerk_aa_fast_wrong.Path>();
		q.add(a[xs][ys]);
		q.add(s[xs][ys]);
		while (!q.isEmpty()) {
			Path p = q.poll();
			boolean lastAvenue = a[p.x][p.y] == p;
			if (lastAvenue) {
				int xn = p.x + da[p.y];
				int yn = p.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn);
					if (p2.c.length >= MAX_TURN) {
						continue;
					}
					if (p2.better(a[xn][yn])) {
						a[xn][yn] = p2;
						q.add(p2);
					}
				}
				xn = p.x;
				yn = p.y + ds[p.x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn, 1);
					if (p2.c.length >= MAX_TURN) {
						continue;
					}
					if (p2.better(s[xn][yn])) {
						s[xn][yn] = p2;
						q.add(p2);
					}
				}
			} else {
				int xn = p.x + da[p.y];
				int yn = p.y;
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn, 1);
					if (p2.c.length >= MAX_TURN) {
						continue;
					}
					if (p2.better(a[xn][yn])) {
						a[xn][yn] = p2;
						q.add(p2);
					}
				}
				xn = p.x;
				yn = p.y + ds[p.x];
				if (0 <= xn && xn < n && 0 <= yn && yn < m) {
					Path p2 = new Path(p, xn, yn);
					if (p2.c.length >= MAX_TURN) {
						continue;
					}
					if (p2.better(s[xn][yn])) {
						s[xn][yn] = p2;
						q.add(p2);
					}
				}
			}
		}
		Path best = null;
		if (a[xf][yf] != null) {
			best = a[xf][yf];
		}
		if (s[xf][yf] != null) {
			if (best == null) {
				best = s[xf][yf];
			} else if (s[xf][yf].better(best)) {
				best = s[xf][yf];
			}
		}
		if (best == null) {
			out.println("Impossible");
		} else {
			out.println(best.start);
			out.println(best.c.length);
			for (int i : best.c) {
				out.print(i + " ");
			}
		}
	}

	class Path {
		public Path(String type, int xs, int ys) {
			start = type;
			len = 0;
			c = new int[1];
			x = xs;
			y = ys;
		}

		public boolean better(Path p) {
			if (p == null) {
				return true;
			}
			if (len < p.len) {
				return true;
			}
			if (len > p.len) {
				return false;
			}
			if (c.length < p.c.length) {
				return true;
			}
			if (c.length > p.c.length) {
				return false;
			}
			int min = Integer.MAX_VALUE;
			for (int i : c) {
				min = Math.min(min, i);
			}
			int min2 = Integer.MAX_VALUE;
			for (int i : p.c) {
				min2 = Math.min(min2, i);
			}
			return min > min2;
		}

		public Path(Path p, int xs, int ys) {
			start = p.start;
			len = p.len + 1;
			x = xs;
			y = ys;
			c = p.c.clone();
			c[c.length - 1]++;
		}

		public Path(Path p, int xs, int ys, int i) {
			start = p.start;
			len = p.len + 1;
			c = new int[0];
			x = xs;
			y = ys;
			c = new int[p.c.length + 1];
			for (int j = 0; j < p.c.length; j++) {
				c[j] = p.c[j];
			}
			c[p.c.length] = i;
		}

		int x, y;
		int len;
		int[] c;
		String start;
	}

	String avenue = "Avenue";
	String street = "Street";
}