import java.io.*;
import java.util.*;
import java.math.*;

public class yownerk_ab implements Runnable {

	final int MAXN = 1000;
	final int MAXM = 1000;
	final int INF = Integer.MAX_VALUE / 2;

	private void solve() throws IOException {
		n = in.nextInt();
		m = in.nextInt();

		assert 1 <= n && n <= MAXN;
		assert 1 <= m && m <= MAXM;

		vs = new int[n];
		for (int i = 0; i < n; ++i) {
			vs[i] = in.nextInt();
			assert Math.abs(vs[i]) == 1;
		}

		va = new int[m];
		for (int i = 0; i < m; ++i) {
			va[i] = in.nextInt();
			assert Math.abs(va[i]) == 1;
		}

		int s = in.nextInt() - 1;
		int a = in.nextInt() - 1;
		int t = in.nextInt() - 1;
		int b = in.nextInt() - 1;

		assert 0 <= s && s < n;
		assert 0 <= t && t < n;
		assert 0 <= a && a < m;
		assert 0 <= b && b < m;
		assert s != t || a != b;

		d = new int[n][m];
		for (int[] di : d) {
			Arrays.fill(di, INF);
		}
		d[s][a] = 0;
		{
			ArrayDeque<Integer> qx = new ArrayDeque<Integer>();
			ArrayDeque<Integer> qy = new ArrayDeque<Integer>();
			qx.add(s);
			qy.add(a);

			while (!qx.isEmpty()) {
				int x = qx.pollFirst();
				int y = qy.pollFirst();
				int tx = x + va[y];
				if (0 <= tx && tx < n && d[tx][y] > d[x][y] + 1) {
					d[tx][y] = d[x][y] + 1;
					qx.addLast(tx);
					qy.addLast(y);
				}
				int ty = y + vs[x];
				if (0 <= ty && ty < m && d[x][ty] > d[x][y] + 1) {
					d[x][ty] = d[x][y] + 1;
					qx.addLast(x);
					qy.addLast(ty);
				}
			}
		}
		c = new int[2][n][m];
		for (int[][] cc : c) {
			for (int[] ci : cc) {
				Arrays.fill(ci, INF);
			}
		}

		c[0][s][a] = 0;
		c[1][s][a] = 0;
		{
			ArrayDeque<Integer> qw = new ArrayDeque<Integer>();
			ArrayDeque<Integer> qx = new ArrayDeque<Integer>();
			ArrayDeque<Integer> qy = new ArrayDeque<Integer>();
			qw.add(0);
			qx.add(s);
			qy.add(a);
			qw.add(1);
			qx.add(s);
			qy.add(a);

			while (!qx.isEmpty()) {
				int w = qw.pollFirst();
				int x = qx.pollFirst();
				int y = qy.pollFirst();

				if (w == 1) {
					int tx = x + va[y];
					if (0 <= tx && tx < n && c[w][tx][y] > c[w][x][y]) {
						c[w][tx][y] = c[w][x][y];
						qw.addFirst(w);
						qx.addFirst(tx);
						qy.addFirst(y);
					}
				} else {
					int ty = y + vs[x];
					if (0 <= ty && ty < m && c[w][x][ty] > c[w][x][y]) {
						c[w][x][ty] = c[w][x][y];
						qw.addFirst(w);
						qx.addFirst(x);
						qy.addFirst(ty);
					}
				}
				if (c[1 ^ w][x][y] > c[w][x][y] + 1) {
					c[1 ^ w][x][y] = c[w][x][y] + 1;
					qw.addLast(1 ^ w);
					qx.addLast(x);
					qy.addLast(y);
				}
			}
		}

		int l = 0;
		int r = n + m;
		u = new int[2][n][m];
		col = 0;
		while (r - l > 1) {
			lb = (l + r) / 2;
			++col;
			if (isWay(s, a, t, b, false)) {
				l = lb;
			} else {
				r = lb;
			}
		}

		ans = new ArrayList<Integer>();
		isAv = false;
		if (l == 0) {
			out.println("Impossible");
		} else {
			++col;
			lb = l;
			if (isWay(s, a, t, b, true));			
			if (isAv) {
				out.println("Avenue");
			} else {
				out.println("Street");
			}
			Collections.reverse(ans);
			out.println(ans.size());
			for (int i = 0; i < ans.size(); ++i) {
				if (i > 0) {
					out.print(" ");
				}
				out.print(ans.get(i));
			}
			out.println();
		}
		//System.out.println(t + " " + b + " " + d[t][b] + " " + c[t][b]);
	}

	int[] va, vs;
	int n, m;
	int[][] d;
	int[][][] c;
	int[][][] u;
	int col;
	int lb, tlen;
	
	ArrayList<Integer> ans;
	boolean isAv;
	
	boolean isWay(int sx, int sy, int tx, int ty, boolean restore) {
		++col;
		if (dfs(sx, sy, 0, lb, tx, ty, restore)) {
			if (restore) {
				ans.add(tlen);
			}
			return true;
		}
		++col;
		if (dfs(sx, sy, 1, lb, tx, ty, restore)) {
			if (restore) {
				ans.add(tlen);
			}
			return true;		
		}
		return false;
	}

	private boolean dfs(int x, int y, int dir, int ms, int t, int b, boolean restore) {
		if (x == t && y == b) {
			tlen = 0;
			return true;
		}
		u[dir][x][y] = col;

		if (dir == 1) {
			int tx = x + va[y] * ms;
			if (0 <= tx && tx < n && d[tx][y] == d[x][y] + ms && c[dir][tx][y] == c[dir][x][y] && u[dir][tx][y] != col && dfs(tx, y, dir, 1, t, b, restore)) {
				if (restore) {
					isAv = true;
					tlen += ms;
				}
				return true;
			}
		} else {
			int ty = y + vs[x] * ms;
			if (0 <= ty && ty < m && d[x][ty] == d[x][y] + ms && c[dir][x][ty] == c[dir][x][y] && u[dir][x][ty] != col && dfs(x, ty, dir, 1, t, b, restore)) {
				if (restore) {
					isAv = false;
					tlen += ms;
				}
				return true;
			}
		}
		if (u[1 ^ dir][x][y] != col && c[1 ^ dir][x][y] == c[dir][x][y] + 1 && dfs(x, y, 1 ^ dir, lb, t, b, restore)) {
			if (restore) {
				ans.add(tlen);
				tlen = 0;
			}
			return true;
		}
		return false;
	}

	final String FILE_NAME = "yownerk";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new yownerk_ab()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}