import java.io.*;
import java.util.*;
import java.math.*;

//Kinda O(n^3). Easy to improve to O(nm).
//Should work slow on test
//1000 1000
//-1 1 1 ... 1 -1 -1 ... -1
//1 1 ... 1
//1 1 1000 1000
public class yownerk_ab_wa implements Runnable {

	final int MAXN = 1000;
	final int MAXM = 1000;
	final int INF = Integer.MAX_VALUE / 2;
	
	private void solve() throws IOException {
		n = in.nextInt();
		m = in.nextInt();
		
		assert 1 <= n && n <= MAXN;
		assert 1 <= m && m <= MAXM;
		
		vs = new int[n];
		for (int i = 0; i < n; ++i) {
			vs[i] = in.nextInt();
			assert Math.abs(vs[i]) == 1;
		}
		
		va = new int[m];
		for (int i = 0; i < m; ++i) {
			va[i] = in.nextInt();
			assert Math.abs(va[i]) == 1;
		}
		
		int s = in.nextInt() - 1;
		int a = in.nextInt() - 1;
		int t = in.nextInt() - 1;
		int b = in.nextInt() - 1;
		
		assert 0 <= s && s < n;
		assert 0 <= t && t < n;
		assert 0 <= a && a < m;
		assert 0 <= b && b < m;		
		assert s != t || a != b;
		
		d = new int[n][m];
		for (int[] di : d) {
			Arrays.fill(di, INF);			
		}		
		d[s][a] = 0;
		ArrayDeque<Integer> qx = new ArrayDeque<Integer>();
		ArrayDeque<Integer> qy = new ArrayDeque<Integer>();
		qx.add(s);
		qy.add(a);
		
		while (!qx.isEmpty()) {
			int x = qx.pollFirst();
			int y = qy.pollFirst();
			int tx = x + va[y];
			if (0 <= tx && tx < n && d[tx][y] > d[x][y] + 1) {
				d[tx][y] = d[x][y] + 1;
				qx.addLast(tx);
				qy.addLast(y);
			}
			int ty = y + vs[x];
			if (0 <= ty && ty < m && d[x][ty] > d[x][y] + 1) {
				d[x][ty] = d[x][y] + 1;
				qx.addLast(x);
				qy.addLast(ty);
			}
		}
		
		c = new int[n][m];
		for (int[] ci : c) {			
			Arrays.fill(ci, INF);						
		}
		
		c[s][a] = -1;
		qx = new ArrayDeque<Integer>();
		qy = new ArrayDeque<Integer>();
		qx.add(s);
		qy.add(a);
		
		while (!qx.isEmpty()) {
			int x = qx.pollFirst();
			int y = qy.pollFirst();			
			
			for (int tx = x + va[y], sh = 1; 0 <= tx && tx < n && d[tx][y] == d[x][y] + sh && c[tx][y] >= c[x][y] + 1; tx += va[y], ++sh) {  // n^3 because of c[tx][y] _>=_ c[x][y] + 1
				c[tx][y] = c[x][y] + 1;
				qx.addLast(tx);
				qy.addLast(y);
			}			
			for (int ty = y + vs[x], sh = 1; 0 <= ty && ty < m && d[x][ty] == d[x][y] + sh && c[x][ty] >= c[x][y] + 1; ty += vs[x], ++sh) {
				c[x][ty] = c[x][y] + 1;
				qx.addLast(x);
				qy.addLast(ty);
			}			
		}
		
//		System.out.println(c[s][a + vs[s] * 277]);
		
		int l = 0;
		int r = n + m;
		u = new int[n][m];
		col = 0;
		while (r - l > 1) {
			int lb = (l + r) / 2;
			++col;
			if (dfs(s, a, t, b, lb, false)) {
				l = lb;
			} else {
				r = lb;
			}
		}
		
		ans = new ArrayList<Integer>();
		isAv = false;
		if (l == 0) {
			out.println("Impossible");
		} else {
			++col;
			dfs(s, a, t, b, l, true);
			if (isAv) {
				out.println("Avenue");
			} else {
				out.println("Street");
			}
			Collections.reverse(ans);
			out.println(ans.size());
			for (int i = 0; i < ans.size(); ++i) {
				if (i > 0) {
					out.print(" ");
				}
				out.print(ans.get(i));
			}
			out.println();
		}
//		System.out.println(t + " " + b + " " + d[t][b] + " " + c[t][b]);
	}

	int[] va, vs;
	int n, m;
	int[][] d;
	int[][] c;
	
	ArrayList<Integer> ans; 
	boolean isAv;
	
	private boolean dfs(int x, int y, int t, int b, int lb, boolean restore) {
		if (x == t && y == b) {
			return true;
		}
		u[x][y] = col;
				
		for (int tx = x + va[y] * lb,  sh = lb; 0 <= tx && tx < n && d[tx][y] == d[x][y] + sh && c[tx][y] == c[x][y] + 1; tx += va[y], ++sh) {
			if (u[tx][y] != col && dfs(tx, y, t, b, lb, restore)) {
				if (restore) {
					isAv = true;
					ans.add(sh);
				}
				return true;
			}
		}			
		for (int ty = y + vs[x] * lb, sh = lb; 0 <= ty && ty < m && d[x][ty] == d[x][y] + sh && c[x][ty] == c[x][y] + 1; ty += vs[x], ++sh) {
			if (u[x][ty] != col && dfs(x, ty, t, b, lb, restore)) {
				if (restore) {
					isAv = false;
					ans.add(sh);
				}
				return true;
			}
		}		
		return false;
	}

	int[][] u;
	int col;
	final String FILE_NAME = "yownerk";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new yownerk_ab_wa()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}