import java.io.*;
import java.util.*;

public class yownerk_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new yownerk_sp()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "yownerk";

	int MAX = 1000;

	public void solve() throws IOException {
		n = nextInt();
		myAssert((1 <= n) && (n <= MAX), "Wrong n");
		m = nextInt();
		myAssert((1 <= m) && (m <= MAX), "Wrong m");
		d1 = new int[n];
		for (int i = 0; i < n; i++) {
			d1[i] = nextInt();
			myAssert(Math.abs(d1[i]) == 1, "Wrong d1");
		}
		d2 = new int[m];
		for (int j = 0; j < m; j++) {
			d2[j] = nextInt();
			myAssert(Math.abs(d2[j]) == 1, "Wrong d2");
		}
		int s = nextInt() - 1;
		myAssert((0 <= s) && (s < n), "Wrong s");
		int a = nextInt() - 1;
		myAssert((0 <= a) && (a < m), "Wrong a");
		t = nextInt() - 1;
		myAssert((0 <= t) && (t < n), "Wrong t");
		b = nextInt() - 1;
		myAssert((0 <= b) && (b < m), "Wrong b");

		d = new int[n][m];
		for (int i = 0; i < n; i++) {
			Arrays.fill(d[i], Integer.MAX_VALUE / 2);
		}
		d[s][a] = 0;
		int[] qx = new int[n * m];
		int[] qy = new int[n * m];
		int beg = 0;
		int end = 1;
		qx[0] = s;
		qy[0] = a;
		while (beg != end && d[t][b] >= Integer.MAX_VALUE / 2) {
			int x = qx[beg];
			int y = qy[beg];
			beg++;
			if (x + d2[y] >= 0 && x + d2[y] < n
					&& d[x + d2[y]][y] > d[x][y] + 1) {
				d[x + d2[y]][y] = d[x][y] + 1;
				qx[end] = x + d2[y];
				qy[end] = y;
				end++;
			}
			if (y + d1[x] >= 0 && y + d1[x] < m
					&& d[x][y + d1[x]] > d[x][y] + 1) {
				d[x][y + d1[x]] = d[x][y] + 1;
				qx[end] = x;
				qy[end] = y + d1[x];
				end++;
			}
		}
		if (d[t][b] >= Integer.MAX_VALUE / 2) {
			out.println("Impossible");
			return;
		}
		dd = new int[2][n][m];
		for (int i = 0; i < dd.length; i++) {
			for (int j = 0; j < dd[i].length; j++) {
				Arrays.fill(dd[i][j], Integer.MAX_VALUE / 2);
			}
		}
		dd[0][s][a] = 0;
		dd[1][s][a] = 0;
		qx = new int[4 * qx.length];
		qy = new int[4 * qy.length];
		int[] qd = new int[qx.length];
		beg = 0;
		end = 2;
		qx[0] = s;
		qy[0] = a;
		qd[0] = 0;
		qx[1] = s;
		qy[1] = a;
		qd[1] = 1;
		while (beg != end) {
			int x = qx[beg];
			int y = qy[beg];
			int dir = qd[beg];
			beg++;
//			System.err.println(x + " "+ y + " " + dir + " "+ dd[dir][x][y]);
			if (dir == 0) {
				int xx = x + d2[y];
				if (xx >= 0 && xx < n && d[xx][y] == d[x][y] + 1
						&& dd[dir][xx][y] > dd[dir][x][y]) {
					dd[dir][xx][y] = dd[dir][x][y];
					qx[end] = xx;
					qy[end] = y;
					qd[end] = dir;
					end++;
				}
				int yy = y + d1[x];
				if (yy >= 0 && yy < m && d[x][yy] == d[x][y] + 1
						&& dd[dir ^ 1][x][yy] > dd[dir][x][y] + 1) {
					dd[dir ^ 1][x][yy] = dd[dir][x][y] + 1;
					qx[end] = x;
					qy[end] = yy;
					qd[end] = dir ^ 1;
					end++;
				}
			} else {
				int xx = x + d2[y];
				if (xx >= 0 && xx < n && d[xx][y] == d[x][y] + 1
						&& dd[dir ^ 1][xx][y] > dd[dir][x][y] + 1) {
					dd[dir ^ 1][xx][y] = dd[dir][x][y] + 1;
					qx[end] = xx;
					qy[end] = y;
					qd[end] = dir ^ 1;
					end++;
				}
				int yy = y + d1[x];
				if (yy >= 0 && yy < m && d[x][yy] == d[x][y] + 1
						&& dd[dir][x][yy] > dd[dir][x][y]) {
					dd[dir][x][yy] = dd[dir][x][y];
					qx[end] = x;
					qy[end] = yy;
					qd[end] = dir;
					end++;
				}
			}
		}
		int l = 1;
		int r = Math.max(n, m) + 1;
		q = new int[2][n][m];
		ans = new int[2 * n * m];
		while (r - l > 1) {
			int mid = (l + r) / 2;
			qlen++;
			sz = 1;
			ans[0] = mid;
			boolean t1 = dfs(s + d2[a] * mid, a, 0, mid);
			boolean t2 = true;
			if (!t1) {
				sz = 1;
				qlen++;
				ans[0] = mid;
				t2 = dfs(s, a + d1[s] * mid, 1, mid);
			}
			if (t2) {
				l = mid;
			} else {
				r = mid;
			}
		}
		sz = 1;
		ans[0] = l;
		qlen++;
		if (dfs(s + d2[a] * l, a, 0, l)) {
			out.println("Avenue");
			out.println(sz);
			for (int i = sz - 1; i >= 0; i--) {
				out.print(ans[i] + " ");
			}
		} else {
			sz = 1;
			ans[0] = l;
			qlen++;
			if (dfs(s, a + d1[s] * l, 1, l)) {
				out.println("Street");
				out.println(sz);
				for (int i = sz - 1; i >= 0; i--) {
					out.print(ans[i] + " ");
				}
			} else {
				out.println("WTF?");
			}
		}
	}

	int[][] d;
	int[][][] dd;
	int[][][] q;
	int qlen = 0;
	int[] d1, d2;
	int n, m, t, b;
	int[] ans;
	int sz;

	boolean dfs(int x, int y, int dir, int l) {
		if (x < 0 || x >= n || y < 0 || y >= m) return false;
		if (x == t && y == b && dd[dir][x][y] <= dd[dir ^ 1][x][y])
			return true;
		if (q[dir][x][y] == qlen)
			return false;
		q[dir][x][y] = qlen;
		if (dir == 0) {
			int xx = x + d2[y];
			if (xx >= 0 && xx < n && d[xx][y] == d[x][y] + 1
					&& dd[dir][xx][y] == dd[dir][x][y] && dfs(xx, y, dir, l)) {
				ans[sz - 1]++;
				return true;
			}
			int yy = y + d1[x] * l;
			if (yy >= 0 && yy < m && d[x][yy] == d[x][y] + l
					&& dd[dir ^ 1][x][yy] == dd[dir][x][y] + 1
					&& dfs(x, yy, dir ^ 1, l)) {
				ans[sz++] = l;
				return true;
			}
		} else {
			int xx = x + d2[y] * l;
			if (xx >= 0 && xx < n && d[xx][y] == d[x][y] + l
					&& dd[dir ^ 1][xx][y] == dd[dir][x][y] + 1
					&& dfs(xx, y, dir ^ 1, l)) {
				ans[sz++] = l;
				return true;
			}
			int yy = y + d1[x];
			if (yy >= 0 && yy < m && d[x][yy] == d[x][y] + 1
					&& dd[dir][x][yy] == dd[dir][x][y] && dfs(x, yy, dir, l)) {
				ans[sz - 1]++;
				return true;
			}
		}
		return false;
	}
}
