import java.io.*;
import java.util.*;

public class yownerk_sp_crazy2 implements Runnable {

	public static void main(String[] args) {
		new Thread(new yownerk_sp_crazy2()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "yownerk";

	class Route implements Comparable<Route> {
		int start, slen, min;
		int len1, len2, len3, len4, len5, len;

		@Override
		public int compareTo(Route o) {
			if (slen != o.slen)
				return slen - o.slen;
			if (len != o.len)
				return len - o.len;
			return o.min - min;
		}

		Route(int dir) {
			len = 1;
			start = dir;
			slen = 0;
			min = Integer.MAX_VALUE;
		}

		Route(Route r) {
			len = r.len;
			len1 = r.len1;
			len2 = r.len2;
			len3 = r.len3;
			len4 = r.len4;
			len5 = r.len5;
			if (len == 1) {
				len1++;
				min = len1;
			} else if (len == 2) {
				len2++;
				min = Math.min(len1, len2);
			} else if (len == 3) {
				len3++;
				min = Math.min(len1, Math.min(len2, len3));
			} else if (len == 4) {
				len4++;
				min = Math.min(len1, Math.min(len2, Math.min(len3, len4)));
			} else if (len == 5) {
				len5++;
				min = Math.min(len1,
						Math.min(len2, Math.min(len3, Math.min(len4, len5))));
			}
			slen = r.slen + 1;
			start = r.start;
		}

		Route(Route r, int l) {
			len = r.len + 1;
			min = 1;
			len1 = r.len1;
			len2 = r.len2;
			len3 = r.len3;
			len4 = r.len4;
			len5 = r.len5;
			if (len == 2) {
				len2 = 1;
			} else if (len == 3) {
				len3 = 1;
			} else if (len == 4) {
				len4 = 1;
			} else if (len == 5) {
				len5 = 1;
			}
			slen = r.slen + l;
			start = r.start;
		}

		@Override
		public String toString() {
			String ret = start == 0 ? "Avenue" : "Street";
			ret += "\n" + len + "\n";
			if (len >= 1) {
				ret += len1 + " ";
				if (len >= 2) {
					ret += len2 + " ";
					if (len >= 3) {
						ret += len3 + " ";
						if (len >= 4) {
							ret += len4 + " ";
							if (len >= 5) {
								ret += len5 + " ";
							}
						}
					}
				}
			}
			return ret;
		}
	}

	class Position {
		int x, y, dir;

		Position(int x, int y, int dir) {
			this.x = x;
			this.y = y;
			this.dir = dir;
		}
	}

	final static private int MAX = 1000;

	int[] qx, qy, qd;
	int head = 0;
	int tail = 0;
	boolean[][][] inQ;

	void put(int x, int y, int d) {
		if (inQ[d][x][y])
			return;
		qx[tail] = x;
		qy[tail] = y;
		qd[tail] = d;
		tail++;
		inQ[d][x][y] = true;
	}

	public void solve() throws IOException {
		int n = nextInt();
		myAssert((1 <= n) && (n <= MAX), "Wrong n");
		int m = nextInt();
		myAssert((1 <= m) && (m <= MAX), "Wrong m");
		int[] d1 = new int[n];
		for (int i = 0; i < n; i++) {
			d1[i] = nextInt();
			myAssert(Math.abs(d1[i]) == 1, "Wrong d1");
		}
		int[] d2 = new int[m];
		for (int j = 0; j < m; j++) {
			d2[j] = nextInt();
			myAssert(Math.abs(d2[j]) == 1, "Wrong d2");
		}
		int s = nextInt() - 1;
		myAssert((0 <= s) && (s < MAX), "Wrong s");
		int a = nextInt() - 1;
		myAssert((0 <= a) && (a < MAX), "Wrong a");
		int t = nextInt() - 1;
		myAssert((0 <= t) && (t < MAX), "Wrong t");
		int b = nextInt() - 1;
		myAssert((0 <= b) && (b < MAX), "Wrong b");

		inQ = new boolean[2][n][m];
		Route[][][] r = new Route[2][n][m];
		r[0][s][a] = new Route(0);
		r[1][s][a] = new Route(1);
		qx = new int[4 * n * m];
		qy = new int[4 * n * m];
		qd = new int[4 * n * m];
		put(s, a, 0);
		put(s, a, 1);
		int cnt = 0;
		while (head != tail) {
			int x = qx[head];
			int y = qy[head];
			int dir = qd[head];
			inQ[dir][x][y] = false;
			head++;
			Route p = r[dir][x][y];
			int xx = x + d2[y];
			if (xx >= 0 && xx < n && (r[0][xx][y] == null || r[0][xx][y].slen > p.slen)) {
				Route nr = null;
				if (dir == 0) {
					nr = new Route(p);
				} else {
					nr = new Route(p, 1);
				}
				cnt++;
				if (r[0][xx][y] == null || r[0][xx][y].compareTo(nr) > 0) {
					r[0][xx][y] = nr;
					put(xx, y, 0);
				}
			}
			int yy = y + d1[x];
			if (yy >= 0 && yy < m && (r[1][x][yy] == null || r[1][x][yy].slen > p.slen)) {
				Route nr = null;
				if (dir == 1) {
					nr = new Route(p);
				} else {
					nr = new Route(p, 1);
				}
				cnt++;
				if (r[1][x][yy] == null || r[1][x][yy].compareTo(nr) > 0) {
					r[1][x][yy] = nr;
					put(x, yy, 1);
				}
			}
		}
		
		System.out.println(cnt);
		Route ans = r[0][t][b];
		if (ans == null
				|| (r[1][t][b] != null && r[1][t][b].compareTo(ans) <= 0)) {
			ans = r[1][t][b];
		}
		if (ans == null) {
			out.println("Impossible");
		} else {
			out.println(ans);
		}
	}
}
