import java.io.*;
import java.util.*;

public class yownerk_sp_fast implements Runnable {

	public static void main(String[] args) {
		new Thread(new yownerk_sp_fast()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "yownerk";

	class Route implements Comparable<Route> {
		int start, slen, min, num;
		Route prev;
		int len;
		int last;
//		int[] lens;

		@Override
		public int compareTo(Route o) {
			if (slen != o.slen)
				return slen - o.slen;
			if (len != o.len)
				return len - o.len;
			int m = Math.min(min, last);
			int om = Math.min(o.min, o.last);
			return om - m;
		}

		Route(int dir) {
			len = 1;
			last = 0;
			prev = null;
			start = dir;
			slen = 0;
			min = Integer.MAX_VALUE;
		}

		Route(Route r) {
			len = r.len;
			last = r.last + 1;
			slen = r.slen + 1;
			start = r.start;
			min = r.min;
			prev = r.prev;
		}

		Route(Route r, int l) {
			prev = r;
			len = r.len + 1;
			min = Math.min(r.min, r.last);
			last = l;
			slen = r.slen + l;
			min = Math.min(r.min, len);
			start = r.start;
		}

		@Override
		public String toString() {
			String ret = start == 0 ? "Avenue" : "Street";
			ret += "\n" + len + "\n";
			ArrayList<Integer> al = new ArrayList<Integer>();
			Route r = this;
			while (r != null) {
				al.add(r.last);
				r = r.prev;
			}
			Collections.reverse(al);
			for (int x : al) {
				ret += x + " ";
			}
			return ret;
		}
	}

	class Position {
		int x, y, dir;

		Position(int x, int y, int dir) {
			this.x = x;
			this.y = y;
			this.dir = dir;
		}
	}

	final static private int MAX = 1000;

	int[] qx, qy, qd;
	int head = 0;
	int tail = 0;
	boolean[][][] inQ;

	void put(int x, int y, int d) {
		if (inQ[x][y][d])
			return;
		qx[tail] = x;
		qy[tail] = y;
		qd[tail] = d;
		tail++;
		inQ[x][y][d] = true;
	}

	public void solve() throws IOException {
		int n = nextInt();
		myAssert((1 <= n) && (n <= MAX), "Wrong n");
		int m = nextInt();
		myAssert((1 <= m) && (m <= MAX), "Wrong m");
		int[] d1 = new int[n];
		for (int i = 0; i < n; i++) {
			d1[i] = nextInt();
			myAssert(Math.abs(d1[i]) == 1, "Wrong d1");
		}
		int[] d2 = new int[m];
		for (int j = 0; j < m; j++) {
			d2[j] = nextInt();
			myAssert(Math.abs(d2[j]) == 1, "Wrong d2");
		}
		int s = nextInt() - 1;
		myAssert((0 <= s) && (s < MAX), "Wrong s");
		int a = nextInt() - 1;
		myAssert((0 <= a) && (a < MAX), "Wrong a");
		int t = nextInt() - 1;
		myAssert((0 <= t) && (t < MAX), "Wrong t");
		int b = nextInt() - 1;
		myAssert((0 <= b) && (b < MAX), "Wrong b");

		inQ = new boolean[n][m][2];
		Route[][][] r = new Route[n][m][2];
		r[s][a][0] = new Route(0);
		r[s][a][1] = new Route(1);
		qx = new int[10 * n * m];
		qy = new int[10 * n * m];
		qd = new int[10 * n * m];
		put(s, a, 0);
		put(s, a, 1);
		int cnt = 0;
		while (head != tail) {
			int x = qx[head];
			int y = qy[head];
			int dir = qd[head];
			inQ[x][y][dir] = false;
			head++;
			Route p = r[x][y][dir];
			int xx = x + d2[y];
			if (xx >= 0 && xx < n && (r[xx][y][0] == null || r[xx][y][0].slen > p.slen)) {
				Route nr = null;
				if (dir == 0) {
					nr = new Route(p);
				} else {
					nr = new Route(p, 1);
				}
				cnt++;
				if (r[xx][y][0] == null || r[xx][y][0].compareTo(nr) > 0) {
					r[xx][y][0] = nr;
					put(xx, y, 0);
				}
			}
			int yy = y + d1[x];
			if (yy >= 0 && yy < m && (r[x][yy][1] == null || r[x][yy][1].slen > p.slen)) {
				Route nr = null;
				if (dir == 1) {
					nr = new Route(p);
				} else {
					nr = new Route(p, 1);
				}
				cnt++;
				if (r[x][yy][1] == null || r[x][yy][1].compareTo(nr) > 0) {
					r[x][yy][1] = nr;
					put(x, yy, 1);
				}
			}
		}
		
		System.out.println(cnt);
		Route ans = r[t][b][0];
		if (ans == null
				|| (r[t][b][1] != null && r[t][b][1].compareTo(ans) <= 0)) {
			ans = r[t][b][1];
		}
		if (ans == null) {
			out.println("Impossible");
		} else {
			out.println(ans);
		}
	}
}
