import java.io.*;
import java.util.*;

public class yownerk_sp_n3 implements Runnable {

	public static void main(String[] args) {
		new Thread(new yownerk_sp_n3()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "yownerk";
	
	static int rnums = 0;
	
	class Route implements Comparable<Route> {
		int start, slen, min, num;
		int[] lens;
		
		@Override
		public int compareTo(Route o) {
			if (slen != o.slen) return slen - o.slen;
			if (lens.length != o.lens.length) return lens.length - o.lens.length;
			return o.min - min;
		}
		
		Route(int dir) {
			lens = new int[0];
			start = dir;
			slen = 0;
			min = Integer.MAX_VALUE;
			num = rnums++;
		}
		
		Route(Route r, int len) {
			lens = new int[r.lens.length + 1];
			System.arraycopy(r.lens, 0, lens, 0, r.lens.length);
			lens[r.lens.length] = len;
			slen = r.slen + len;
			min = Math.min(r.min, len);
			start = r.start;
			num = rnums++;
		}
		
		@Override
		public String toString() {
			String ret = start == 0 ? "Avenue" : "Street";
			ret += "\n" + lens.length + "\n";
			for (int x : lens) {
				ret += x + " ";
			}
			return ret;
		}
	}
	
	class Position implements Comparable<Position> {
		int x, y, d;
		Route r;
		
		Position(int xx, int yy, int dd) {
			x = xx;
			y = yy;
			d = dd;
		}

		@Override
		public int compareTo(Position o) {
			int c = r.compareTo(o.r);
			if (c != 0) return c;
			if (x != o.x) return x - o.x;
			if (y != o.y) return y - o.y;
			if (d != o.d) return d - o.d;
			return 0;
		}
	}
	
	final static private int MAX = 1000; 

	public void solve() throws IOException {
		int n = nextInt();
		myAssert((1 <= n) && (n <= MAX), "Wrong n");
		int m = nextInt();
		myAssert((1 <= m) && (m <= MAX), "Wrong m");
		int[] d1 = new int[n];
		for (int i = 0; i < n; i++) {
			d1[i] = nextInt();
			myAssert(Math.abs(d1[i]) == 1, "Wrong d1");
		}
		int[] d2 = new int[m];
		for (int j = 0; j < m; j++) {
			d2[j] = nextInt();
			myAssert(Math.abs(d2[j]) == 1, "Wrong d2");
		}
		int s = nextInt() - 1;
		myAssert((0 <= s) && (s < MAX), "Wrong s");
		int a = nextInt() - 1;
		myAssert((0 <= a) && (a < MAX), "Wrong a");
		int t = nextInt() - 1;
		myAssert((0 <= t) && (t < MAX), "Wrong t");
		int b = nextInt() - 1;
		myAssert((0 <= b) && (b < MAX), "Wrong b");
		Position[][][] r = new Position[n][m][2];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				r[i][j][0] = new Position(i, j, 0);
				r[i][j][1] = new Position(i, j, 1);
			}
		}
		TreeSet<Position> ts = new TreeSet<Position>();
		Route tr = new Route(0);
		for (int i = s; i >= 0 && i < n; i += d2[a]) {
			Route nr = new Route(tr, Math.abs(i - s));
			r[i][a][1].r = nr;
			ts.add(r[i][a][1]);
		}
		tr = new Route(1);
		for (int j = a; j >= 0 && j < m; j += d1[s]) {
			Route nr = new Route(tr, Math.abs(j - a));
			r[s][j][0].r = nr;
			ts.add(r[s][j][0]);
		}
		while (!ts.isEmpty()) {
			Position p = ts.pollFirst();
//			System.out.println(p.r);
			if (p.d == 0) {
				for (int i = p.x + d2[p.y]; i >= 0 && i < n; i += d2[p.y]) {
					Route nr = new Route(p.r, Math.abs(i - p.x));
					if (r[i][p.y][1].r == null || r[i][p.y][1].r.compareTo(nr) > 0) {
						if (r[i][p.y][1].r != null) {
							ts.remove(r[i][p.y][1]);
						}
						r[i][p.y][1].r = nr;
						ts.add(r[i][p.y][1]);
					} else {
						break;
					}
				}
			} else {
				for (int j = p.y + d1[p.x]; j >= 0 && j < m; j += d1[p.x]) {
					Route nr = new Route(p.r, Math.abs(j - p.y));
					if (r[p.x][j][0].r == null || r[p.x][j][0].r.compareTo(nr) > 0) {
						if (r[p.x][j][0].r != null) {
							ts.remove(r[p.x][j][0]);
						}
						r[p.x][j][0].r = nr;
						ts.add(r[p.x][j][0]);
					} else {
						break;
					}
				}
			}
		}
		Route ans = r[t][b][0].r;
		if (ans == null || (r[t][b][1].r != null && r[t][b][1].r.compareTo(ans) <= 0)) {
			ans = r[t][b][1].r;
		}
		if (ans == null) {
			out.println("Impossible");
		} else {
			out.println(ans);
		}
	}
}
